<?php 
require_once('Basededatos.php');

class Configuracion extends Database
{
    
	public function Configuracion()
	{
 		parent::Database();
 		
	}

	
	


 public static function guardar($id_usuario)
  {
    	 try{
		    $consulta="INSERT configuracion (id_usuario)
			values(?)";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($id_usuario));
		    
		    return true;
		    }catch(PDOException $e)
		    { 
				echo $e;
		      return false;
		    }
  }

  /**
	* Obtiene el nro y contraseña para loguearse
	* a la base de datos
	* @param $nro    nro del usuario
	* @param $password    contraseña del usuario
	*/
 public static function actualizar($id,$id_usuario,$intervalo1,$intervalo2,$cuotas1,$cuotas2,$interes)
 {
 
     try{
	    $consulta="UPDATE configuracion 
	    set  
		intervalo1=?,
		intervalo2=?,
		cuotas1=?,
		cuotas2=?,
		interes=?
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($intervalo1,$intervalo2,$cuotas1,$cuotas2,$interes,$id));
	    return true;
    }catch(PDOException $e)
    {
    	echo $e;
      return false;
    }
}
 


 public  function get_configuracion_por_id($id_usuario)
   {  
   	$resultado=-1;
   	try{
	   	$query = parent::getInstance()
	   	->getDb()
	   	->prepare("SELECT * from configuracion where id_usuario=? order by fecha desc limit 1");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				self::guardar($id_usuario);
				$resultado=-1;
			}

	$query = parent::getInstance()
	   	->getDb()
	   	->prepare("SELECT * from configuracion where id_usuario=? order by fecha desc limit 1");
        $query->execute(array($id_usuario)); 
		$row=$query->fetch(PDO::FETCH_OBJ);
		if($row)
		{
			$resultado=$row;
		}

	}catch(PDOException $e)
    {
    	echo $e;
    	$resultado=-1;
    }
	return $resultado;

   }

 
   
  



}


		

 ?>
