<?php 
require_once('Basededatos.php');

class Cuenta extends Database
{
    
	public function Cuenta()
	{
 		parent::Database();
 		
	}

	
	


 public  function guardar_cuenta($id_cliente,$id_usuario,$fecha_inicio,$fecha_final,$valor,$interes,$porcentaje_interes,$cuotas,$valor_diario,$detalle,$intervalo,$id_caja)
  {
  	$valor_total=$valor+$interes;

    	 try{
		    $consulta="INSERT INTO cuenta (id_cliente,id_usuario,fecha_inicio,fecha_final,valor,interes,interes_porcentaje,cuotas,valor_diario,detalle,intervalo,id_caja,valor_total,deuda)
			values(?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($id_cliente,$id_usuario,$fecha_inicio,$fecha_final,$valor,$interes,$porcentaje_interes,$cuotas,$valor_diario,$detalle,$intervalo,$id_caja,$valor_total,$valor_total));
		    $id_cuenta = parent::getInstance()->getDb()->lastInsertId();
		    }catch(PDOException $e)
		    { 
				echo $e;
			}
 
			try{
			//$fecha_inicio_pago=date ( 'Y-m-j');
			$fecha_inicio_pago=$fecha_inicio;
			
			for ($i=0; $i < $cuotas; $i++) {  
                 
				$dia=date('N',strtotime ( $fecha_inicio_pago ));
				$numero=$i;
				$numero++;

				

				if($dia==7){
					//echo "guardar cuota fin";

					$fecha_inicio_pago=date('Y-m-j',strtotime( '+1 day' , strtotime($fecha_inicio_pago))) ;

					$guardar_cuota=self::guardar_cuota($id_cliente,$id_usuario,$id_cuenta,$fecha_inicio_pago,'DEUDA',$numero,$id_caja,$valor_diario);
				}
				else{
//echo "guardar cuota ".$id_cliente.",".$id_usuario.",".$id_cuenta.",".$fecha_inicio_pago.",".'DEUDA'.",".$numero;
					$guardar_cuota=self::guardar_cuota($id_cliente,$id_usuario,$id_cuenta,$fecha_inicio_pago,'DEUDA',$numero,$id_caja,$valor_diario);
			
				}

				$fecha_inicio_pago=date('Y-m-j',strtotime( '+'.$intervalo.' day' , strtotime ( $fecha_inicio_pago ) )) ;
				

			}
			}catch(PDOException $e)
		    { 
				echo "error".$e;
			}

			try{
			// Actualizar fecha final
			$consulta="UPDATE cuenta 
			set  
			fecha_final=? 
			where id=?";
			 $comando=parent::getInstance()->getDb()->prepare($consulta);
			 $comando->execute(array($fecha_inicio_pago,$id_cuenta));
			
		    return true;
		    }catch(PDOException $e)
		    { 
				echo $e;
		      return false;
		}
   		
  }

  /**
	* Obtiene el nro y contraseña para loguearse
	* a la base de datos
	* @param $nro    nro del usuario
	* @param $password    contraseña del usuario
	*/
 public  function actualizar_cuenta($nombre,$negocio,$direccion,$telefono,$latitud,$longitud,$id_cliente)
 {
 
     try{
	    $consulta="UPDATE cliente 
	    set  
		nombre=?,
		negocio=?,
		direccion=?,
		telefono=?,
		latitud=?,
	    longitud=?
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($nombre,$negocio,$direccion,$telefono,$latitud,$longitud,$id_cliente));
	    return true;
    }catch(PDOException $e)
    {
		echo $e;
      return false;
    }
}
 

public  function lista_cuenta_por_cliente($id_cliente)
{  
	$resultado=-1;
	$query = parent::getInstance()->getDb()->prepare("SELECT * from cuenta where id_cliente=? order by fecha desc");
	 $query->execute(array($id_cliente)); 
	 $row=$query->fetchAll();
	 if($row)
	 {
		 $resultado=$row;
	 }
	 else
		 {
			 $resultado=-1;
		 }
 return $resultado;

}


 public  function lista_cuenta()
   {  
   	$resultado=-1;
   	$query = parent::getInstance()->getDb()->prepare("SELECT * from cuenta order by fecha desc");
        $query->execute(); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;

   }

   public  function lista_abonos($id_cuenta)
   {  
   	$resultado=-1;
   	$query = parent::getInstance()->getDb()->prepare("SELECT * from abono where id_cuenta=? order by fecha asc");
        $query->execute(array($id_cuenta)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;
   }

   public  function actualizar_abono_en_cuenta($id_cuenta)
   {  
   	$resultado=-1;
	$monto=0;
   	$query = parent::getInstance()->getDb()->prepare("SELECT IFNULL(sum(monto),0) as monto from abono where id_cuenta=? ");
       $query->execute(array($id_cuenta)); 
	   $row=$query->fetch(PDO::FETCH_OBJ);
						   
		if($row)
		{
			$monto=$row->monto; 
			try{ 
				//actualizar abonos de cuenta 
						$consulta="UPDATE cuenta 
						set  
						abonos=? 
						where id=?"; 
						$comando=parent::getInstance()->getDb()->prepare($consulta);
						$comando->execute(array($monto,$id_cuenta));
						$resultado=true; 
						self::guardar_bitacora($id_usuario,'actualizar_abono_en_cuenta','Monto ->'.$monto.', id_cuenta->'.$id_cuenta);
				  }catch(PDOException $e)
				  {
					self::guardar_bitacora($id_usuario,'actualizar_abono_en_cuenta','Error al actualizar ->'.$e);
			   		//echo $e;
					$resultado=-1;  
				  }
		}
		else
			{
				$resultado=-1;
			}

			

	return $resultado;
   }

   public  function get_cuenta_por_id($id_cuenta)
   {  
   	$resultado=-1;
			try{
				$query = parent::getInstance()
				->getDb()
				->prepare("SELECT c.*,(select count(cu.id_cuenta) from cuota cu where cu.id_cuenta=c.id and cu.atraso>0) as atraso from cuenta c where c.id=? ");
				$query->execute(array($id_cuenta)); 
				$row=$query->fetch(PDO::FETCH_OBJ);
		 
				$resultado=$row; 
				return $resultado;
			}catch(PDOException $e)
			{
			     return -1;
			}
	}

   public  function lista_cuotas_por_id_cuenta($id_cuenta)
   {  
   	$resultado=-1;
	   try{
			$query = parent::getInstance()->getDb()->prepare("SELECT id, numero, id_cliente, id_cuenta, id_usuario, monto, valor_cuota, estado, fecha, fecha_pago, date(fecha_registro_pago) as fecha_registro_pago, atraso, id_caja 
			 from cuota where id_cuenta=? order by numero asc");
			$query->execute(array($id_cuenta)); 
			$row=$query->fetchAll();
			if($row)
			{
				$resultado=$row;
			}
			else {
					$resultado=-1;
				}
		}catch(PDOException $e)
		{
			echo $e;
			 return -1;
		}
	return $resultado;
   }
 
   
  
 public function guardar_cuota($id_cliente,$id_usuario,$id_cuenta,$fecha_pago,$estado,$numero,$id_caja,$valor_diario)
 {
 	//echo "guardar cuota ".$id_cliente.",".$id_usuario.",".$id_cuenta.",".$fecha_pago.",".$estado.",".$numero;
		try{
		   $consulta="INSERT cuota (id_cliente,id_usuario,id_cuenta,fecha_pago,estado,numero,id_caja,valor_cuota)
		   values(?,?,?,?,?,?,?,?)";
		   $comando=parent::getInstance()->getDb()->prepare($consulta);
		   $comando->execute(array($id_cliente,$id_usuario,$id_cuenta,$fecha_pago,$estado,$numero,$id_caja,$valor_diario));
		   $id_cuota = parent::getInstance()->getDb()->lastInsertId();

		   return true;
		   }catch(PDOException $e)
		   { 
			   echo $e;
			 return false;
		   }
		  
 }

 public  function verificar_coutas_valor($id_cuenta)
 {  
	 $resultado=-1;
	 try{
		  $query = parent::getInstance()->getDb()->prepare("SELECT * from cuota where estado<>'DEUDA' and  id_cuenta=? order by numero asc");
		  $query->execute(array($id_cuenta)); 
		  $row=$query->fetchAll();
		  if($row)
		  {
			  $resultado=$row;
		  }
		  else {
				  $resultado=-1;
			  }
	  }catch(PDOException $e)
	  {
		  echo $e;
		   return -1;
	  }
  return $resultado;
 }

 public static function eliminar_abono($id_usuario,$id_abono,$id_cuenta)
 { 
			 try{
		   $consulta="DELETE FROM abono 
		   where id=?";
		   $comando=parent::getInstance()->getDb()->prepare($consulta);
		   $comando->execute(array($id_abono));
		   self::actualizar_cuota_abono_eliminado($id_cuenta);
			self::actualizar_abono_en_cuenta($id_cuenta);	
		    self::actualizar_deuda($id_cuenta);
		   return true;
		   }catch(PDOException $e)
		   { 
			   self::guardar_bitacora($id_usuario,'eliminar_abono','Error al eliminar la abono ->'.$e);
			   //echo $e;
			 return false;
		   }
 }

 public static function eliminar_cuota($id_usuario,$id_cuota,$id_cuenta)
 { 
			 try{
		   $consulta="UPDATE  cuota 
		   set estado='DEUDA',
		   monto=0,
		   fecha_registro_pago=null
		   where id=?";
		   $comando=parent::getInstance()->getDb()->prepare($consulta);
		   $comando->execute(array($id_cuota));

		   self::actualizar_deuda($id_cuenta);
		   return true;
		   }catch(PDOException $e)
		   { 
			   self::guardar_bitacora($id_usuario,'eliminar_cuota','Error al eliminar la cuota ->'.$e);
			   //echo $e;
			 return false;
		   }
 }

 public static function eliminar_cuota_definitivo($id_usuario,$id_cuenta)
 { 
			 try{
		   $consulta="DELETE FROM cuota 
		   where id_cuenta=?";
		   $comando=parent::getInstance()->getDb()->prepare($consulta);
		   $comando->execute(array($id_cuenta));
 
		   return true;
		   }catch(PDOException $e)
		   { 
			   self::guardar_bitacora($id_usuario,'eliminar_cuota_definitivo','Error al eliminar la cuota ->'.$e);
			   //echo $e;
			 return false;
		   }
 }

 public static function eliminar_cuenta($id_cuenta,$id_usuario)
 { 
	$valor=0;
	$id_caja=0;
	$id_usuario=0;
	$resultado=false;

	try{
		//OBTENER VALOR DE CUENTA
					$query = parent::getInstance()
								->getDb()
								->prepare("SELECT valor,id_usuario,id_caja from cuenta
								 where id_cuenta=?  ");
								 $query->execute(array($id_cuenta));  
								  while($row=$query->fetch(PDO::FETCH_OBJ)) {
										 $valor=$row->valor;
										 $id_caja=$row->id_caja;
										 $id_usuario=$row->id_usuario;
									} 
			  }catch(PDOException $e)
			  {  
				self::guardar_bitacora($id_usuario,'eliminar_cuenta','Error obtener datos de la cuenta ->'.$e);
			   //echo $e; 
			  }

		try{
		   $consulta="DELETE FROM  cuenta where id=?";
		   $comando=parent::getInstance()->getDb()->prepare($consulta);
		   $comando->execute(array($id_cuenta));
 
		   $resultado= true;
		   }catch(PDOException $e)
		   { 
			   self::guardar_bitacora($id_usuario,'eliminar_cuenta','Error al eliminar el cuenta ->'.$e);
			   //echo $e;
			 $resultado=false;
		   }

		   if($resultado==true){
			try{
				//ACTUALIZAR LA CAJA CERRADA
				$consulta="UPDATE caja 
					set  
					monto_cierre=monto_cierre+?  
					where id=? and estado='Cerrada' ";
			
					$comando=parent::getInstance()->getDb()->prepare($consulta);
					$comando->execute(array($valor,$id_caja)); 
		 	}catch(PDOException $e){ 
				self::guardar_bitacora($id_usuario,'eliminar_cuenta','Error al actualizar la caja ->'.$e);
			   //echo $e;
			  }
		   }

	return $resultado;
 }
 


 public  function guardar_pago_cuota(
 $id_cliente,
 $id_usuario,
 $id_cuenta,
 $monto, 
 $cuotas,
 $abono,
 $id_caja)
	{


		$resultado=false;
	   try{
   
		foreach ($cuotas as $value) { 
		  $_id=$value['id'];
		  $_seleccionar=$value['seleccionar']; 
		  if($_seleccionar==1){

			$consulta="UPDATE cuota 
			set  
			monto=?, 
			estado='PAGADO',
			fecha_registro_pago=now(),
			atraso=0,
			id_caja=? 
			where id=?";
	
			$comando=parent::getInstance()->getDb()->prepare($consulta);
			$comando->execute(array($monto,$id_caja,$_id));
			$resultado=true;
		  }
		}

		//agregar abono en la cuenta
		$consulta="UPDATE cuenta 
			set  
			abonos=abonos+?  
			where id=?";
	
			$comando=parent::getInstance()->getDb()->prepare($consulta);
			$comando->execute(array($abono,$id_cuenta));
			$resultado=true;
		//actualizar monto de deuda

		if($abono>0){
			//agregar abono en historial 
			$consulta="INSERT INTO abono (id_cuenta,id_usuario,monto,id_caja) values(?,?,?,?)";
			$comando=parent::getInstance()->getDb()->prepare($consulta);
			$comando->execute(array($id_cuenta,$id_usuario,$abono,$id_caja));
			//self::guardar_bitacora($id_usuario,'guardar_pago_cuota','Insertar Abono ->'.$abono.' -> '.$consulta);
		}
 }catch(PDOException $e)
	  {
		//echo $e; 
		  $resultado=false;
	  }
		//actualizar monto de deuda
		self::actualizar_deuda($id_cuenta);
     
	 
	return $resultado;
  }


public  function actualizar_cuotas_atraso()
{
	$resultado=-1;
	$cont=0;
   try{
//actualizar campos de cuotas con abonos
		$query = parent::getInstance()
					->getDb()
					->prepare("SELECT * from cuota
					 where  estado in ('DEUDA')
					 and date(fecha_pago)<=date(now()) ");
					 $query->execute(array($id_cuenta));  

					  while($row=$query->fetch(PDO::FETCH_OBJ)) { 
								$consulta="UPDATE cuota 
								set     
								atraso=TIMESTAMPDIFF(DAY, fecha_pago, date(now())) 
								where id=?";
								$comando=parent::getInstance()->getDb()->prepare($consulta);
								$comando->execute(array($row->id));
								$cont++;
						}
	$resultado=$cont;
  }catch(PDOException $e)
  {
	//echo $e; 
	  $resultado=-1;
  }
return $resultado;
}

public  function actualizar_cuota_abono_eliminado($id_cuenta)
	{
		$resultado=false;
	   try{ 
		$comando=parent::getInstance()->getDb()->prepare("UPDATE cuota set monto=0,fecha_registro_pago=null,atraso=0, estado='DEUDA' where id_cuenta=? and estado='ABONO'");
		$comando->execute(array($id_cuenta));

			$resultado=true;
	    
	  }catch(PDOException $e)
	  { 
		  $resultado=false;
	  }
	return $resultado;
  }
public  function actualizar_abono($id_cuenta,$abonos )
	{
		$resultado=false;
	   try{
   

//actualizar campos de cuotas con abonos
			$query = parent::getInstance()
						->getDb()
						->prepare("SELECT * from cuota
						 where id_cuenta=? 
						 and estado in ('DEUDA','ABONO')
						 order by id desc");
						 $query->execute(array($id_cuenta)); 
						 $con=0;
						  while($row=$query->fetch(PDO::FETCH_OBJ)) {
					         	$valor_cuota=$row->valor_cuota;
							         if($abonos>=$valor_cuota){
							         	$abonos=$abonos-$valor_cuota;
										$comando=parent::getInstance()->getDb()->prepare("UPDATE cuota set monto=valor_cuota, estado='ABONO' where id=?");
										$comando->execute(array($row->id));
										//echo "abono=".$valor_cuota.",";
							         }else if($abonos>0){
							         	
										$comando=parent::getInstance()->getDb()->prepare("UPDATE cuota set monto=?, estado='ABONO' where id=?");
										$comando->execute(array($abonos,$row->id));
										$abonos=$abonos-$valor_cuota;
										//echo "abono=".$abonos.",";
							         }
					        }

			$resultado=true;
	    
	  }catch(PDOException $e)
	  {
		self::guardar_bitacora(null,'actualizar_abono','Error->'.$e);
		  $resultado=false;
	  }
	return $resultado;
  }

 public  function actualizar_deuda($id_cuenta )
	{
		$resultado=false;
	   try{


	//actualizar deudas				        
		 $query = parent::getInstance()->getDb()->prepare("SELECT total,pagado,abonos,(total-pagado-abonos) as deuda from( SELECT c.valor_total as total,
		 	case when (select sum(cu.monto) from cuota cu where cu.id_cuenta=c.id and cu.estado='PAGADO') is null then 0 else 
		 	(select sum(cu.monto) from cuota cu where cu.id_cuenta=c.id and cu.estado='PAGADO') end as pagado,
		 	case when (select sum(ab.monto) from abono ab where ab.id_cuenta=c.id) is null then 0 else 
		 	(select sum(ab.monto) from abono ab where ab.id_cuenta=c.id) end abonos    
		 	from cuenta c where c.id=? )tabla");
				$query->execute(array($id_cuenta)); 
				$row=$query->fetch(PDO::FETCH_OBJ);
			$total=$row->total;
			$pagado=$row->pagado;
			$deuda=$row->deuda;	
			$abonos=$row->abonos;
		//actualizar abono
		$cuenta_update=self::actualizar_abono($id_cuenta,$abonos);
  //echo $cuenta_update;
  		//self::guardar_bitacora(null,'actualizar_deuda','id_cuenta:'.$id_cuenta.',total:'.$total.',pagado:'.$pagado.',abonos:'.$abonos.',deuda:'.$deuda);
 
  

		//	echo "t.".$total."=p.".$pagado.",d=".$deuda.",a=".$abonos;
			$consulta="UPDATE cuenta 
			set  
			deuda=? 
			where id=?";
			//echo "t:".$total." pagado:".$pagado." deuda:".$deuda." id_cuenta:".$id_cuenta;
	
			$comando=parent::getInstance()->getDb()->prepare($consulta);
			$comando->execute(array($deuda,$id_cuenta));
			$resultado=true;
		 

     
	  }catch(PDOException $e)
	  {
		echo $e; 
		  $resultado=false;
	  }
	return $resultado;
  }

  
public  function lista_cliente_cuenta_por_id_caja($id_caja,$id_usuario)
{  
	$resultado=-1;
	try{ 
	$query = parent::getInstance()
	->getDb()
	->prepare("SELECT cu.id as id_cuenta,
	 0 as id_abono,
	 cl.*,
	 (cu.valor) as monto_pago
	 from caja c, 
	 cliente cl, 
	 cuenta cu 
	 where cl.id=cu.id_cliente 
	 and c.id =cu.id_caja  
	 and c.id=? 
	 order by cu.id asc");
	 $query->execute(array($id_caja)); 
	 $row=$query->fetchAll();
	 if($row)
	 {
		 $resultado=$row;
	 }
	 else
		 {
			 $resultado=-1;
		 }
 }catch(PDOException $e)
 { 
			 echo $e; 
 }

 return $resultado;
}



public static function guardar_bitacora($id_usuario,$tipo,$detalle)
{ 
 try{
	 $usuario="";
	 $query = parent::getInstance()->getDb()->prepare("SELECT * from usuario where id=?");
	 $query->execute(array($id_usuario)); 
	 $row=$query->fetch(PDO::FETCH_OBJ);
	  
	 if($row)
	 {
		 $usuario=$row->usuario;
	 }

 $consulta="INSERT INTO bitacora (usuario,id_usuario,tipo,detalle)
 values(?,?,?,?)";
 $comando=parent::getInstance()
 ->getDb()
 ->prepare($consulta);
 $comando->execute(array($usuario,$id_usuario,$tipo,$detalle)); 
 
 return true;
 }catch(PDOException $e)
 { 
	 echo $e;
   return false;
 }
}


}


		

 ?>
