<?php 
require_once('Basededatos.php');

class Gasto extends Database
{
    
	public function Gasto()
	{
 		parent::Database();
 		
	}

	
	


 public static function guardar($id_usuario,$monto,$descripcion,$id_caja)
  {
    	 try{
		    $consulta="INSERT gasto (id_usuario,monto,descripcion,id_caja)
			values(?,?,?,?)";
		    $comando=parent::getInstance()->getDb()->prepare($consulta);
		    $comando->execute(array($id_usuario,$monto,$descripcion,$id_caja));
		    
		    return true;
		    }catch(PDOException $e)
		    { 
				echo $e;
		      return false;
		    }
   		
    

  }

  /**
	* Obtiene el nro y contraseña para loguearse
	* a la base de datos
	* @param $nro    nro del usuario
	* @param $password    contraseña del usuario
	*/
 public static function actualizar($id,$id_usuario,$monto,$descripcion)
 {
 
     try{
	    $consulta="UPDATE gasto 
	    set  
		id_usuario=?,
		monto=?,
		descripcion=? 
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($id_usuario,$monto,$descripcion,$id));
	    return true;
    }catch(PDOException $e)
    {
      return false;
    }
}
 


 public  function lista($id_usuario)
   {  
   	$resultado=-1;
   	$query = parent::getInstance()->getDb()->prepare("SELECT * from gasto where id_usuario=? order by fecha desc");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;

   }

 
   
  



}


		

 ?>
