<?php 
/**
* Loguear al usuario 
*/
require_once 'clscliente.php';
require_once 'clsbitacora.php';

//if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	
	// Decodificando formato Json
	switch ($_GET['opcion']) {
		case 'guardar_cliente':
			guardar_cliente();
			break;
		case 'actualizar_cliente':
			actualizar_cliente();
			break;
		case 'actualizar_cliente_notificacion':
			actualizar_cliente_notificacion();
			break;  
		case 'lista_cliente':
			lista_cliente();
			break;	
		case 'lista_de_cliente_cerca':
			lista_de_cliente_cerca();
			break;	
		case 'eliminar_cliente':
			eliminar_cliente();
			break;			
			
		 
		default:
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Actualice la aplicación.' ));
			break;
	}

 
function guardar_cliente()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	if(Cliente::existe_cliente_por_ci($dato['ci'])==false){
			$row=Cliente::guardar_cliente($dato['ci'],$dato['nombre'],$dato['apellido'],$dato['negocio'],$dato['direccion'],$dato['telefono'],$dato['latitud'],$dato['longitud'],$dato['id_usuario']);
			if($row===true) {
			print json_encode(array('suceso' => '1' ,'mensaje'=>'Guardado Correctamente.'));
			}
			else
			{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al guardar el Cliente. Complete todos los campos.' ));
					}	
		}else{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Ya existe un registro con el mismo C.I.' ));
		}
}
function actualizar_cliente()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cliente::actualizar_cliente($dato['ci'],$dato['nombre'],$dato['apellido'],$dato['negocio'],$dato['direccion'],$dato['telefono'],$dato['latitud'],$dato['longitud'],$dato['id_cliente']);
	if($row==true){
		print json_encode(array('suceso' => '1' ,'mensaje'=>'Correcto.'));
	}
	else{
		print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar el cliente.' ));
	}	
}

function eliminar_cliente()
{
	$dato=json_decode(file_get_contents("php://input"),true); 
			$row=Cliente::eliminar_cliente($dato['id_cliente'],$dato['id_usuario']);
			if($row===true) {
			$bitacora=Bitacora::guardar($dato['id_usuario'],'eliminar_cliente',json_encode($dato));
			print json_encode(array('suceso' => '1' ,'mensaje'=>'Eliminado correctamente.'));
			}
			else
			{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al eliminar el Cliente. Verificar sus CUENTAS pendientes.' ));
			 }	
		 
}
function actualizar_cliente_notificacion()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cliente::actualizar_cliente_notificacion($dato['id_usuario'],$dato['id_cliente'],$dato['notificacion']);
	if($row===true){
		print json_encode(array('suceso' => '1' ,'mensaje'=>'Se actualizo la notificación.'));
	}
	else{
		print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar el cliente.' ));
	}	
}

function lista_cliente()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cliente::lista_cliente($dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cliente"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function lista_de_cliente_cerca()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cliente::distancia_cliente_cerca_usuario($dato['id_usuario'],$dato['latitud'],$dato['longitud']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cliente"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}
 


 ?>
