<?php 
/**
* Loguear al usuario 
*/
require_once 'clscuenta.php';
require_once 'clscaja.php';
require_once 'clsbitacora.php';

//if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	
	// Decodificando formato Json
	switch ($_GET['opcion']) {
		case 'guardar_pago_cuota':
			guardar_pago_cuota();
			break;
		case 'guardar_cuenta':
			guardar_cuenta();
			break;
		case 'actualizar_cuenta':
			actualizar_cuenta();
			break; 
		case 'eliminar_cuota':
			eliminar_cuota();
			break; 
		case 'lista_cuenta':
			lista_cuenta();
			break;	
		case 'lista_abonos':
			lista_abonos();
			break;		
		case 'lista_cuenta_por_cliente':
				lista_cuenta_por_cliente();
				break;	
		case 'obtener_cuenta_por_id':
			obtener_cuenta_por_id();
			break;
		case 'lista_cliente_cuenta_por_id_caja':
			lista_cliente_cuenta_por_id_caja();
			break;	
		case 'actualizar_cuotas_atraso':
			actualizar_cuotas_atraso();
			break;
		case 'eliminar_cuenta':
			eliminar_cuenta();
			break;					
		case 'eliminar_abono':
			eliminar_abono();
			break;	
		
		default:
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Actualice la aplicación.' ));
			break;
	}

 
function guardar_cuenta()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	if(Caja::verificar_caja_abierta_por_id_usuario($dato['id_usuario'])==true){
		$id_caja=Caja::id_caja_abierta_por_id_usuario($dato['id_usuario']);
			$row=Cuenta::guardar_cuenta($dato['id_cliente'],$dato['id_usuario'],$dato['fecha_inicio'],$dato['fecha_final'],$dato['valor'],$dato['interes'],$dato['porcentaje_interes'],$dato['cuotas'],$dato['valor_diario'],$dato['detalle'],$dato['intervalo'],$id_caja);
			if($row===true) {
				$bitacora=Bitacora::guardar($dato['id_usuario'],'guardar_cuenta',json_encode($dato));
				print json_encode(array('suceso' => '1' ,'mensaje'=>'Guardado correctamente.'));
			}
			else {
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al guardar el Cliente.' ));
			}	
		}else{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Realice la apertura de caja' ));
		}
}

function guardar_pago_cuota()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	if(Caja::verificar_caja_abierta_por_id_usuario($dato['id_usuario'])==true){
		$id_caja=Caja::id_caja_abierta_por_id_usuario($dato['id_usuario']);
			$row=Cuenta::guardar_pago_cuota($dato['id_cliente'],$dato['id_usuario'],$dato['id_cuenta'],$dato['monto'],$dato['cuotas'],$dato['abono'],$id_caja);
			if($row===true)
			{
				$bitacora=Bitacora::guardar($dato['id_usuario'],'guardar_pago_cuota',json_encode($dato));
			print json_encode(array('suceso' => '1' ,'mensaje'=>'Guardado correctamente.'));
			}
			else
			{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al guardar el Cliente.' ));
					}	
		}else{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Realice la apertura de caja' ));
		}
}
function actualizar_cuenta()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::actualizar_cliente($dato['nombre'],$dato['negocio'],$dato['direccion'],$dato['telefono'],$dato['latitud'],$dato['longitud'],$dato['id_cliente']);
	if($row===true)
	{// di tiene id_carrera=0 quiere decir q el pedido esta en camino... porque el estado en 0--
		// si el id_carrera=-1 quiere decir que se inicio una carrera y se finalizo.. ey esta en espera a una nueva carrera o finalizar todo el pedido.....
	//	$cargar=conductor::set_puntos($dato['latitud'],$dato['longitud'],$dato['id_pedido']);
	
	print json_encode(array('suceso' => '1' ,'mensaje'=>'Correcto.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar el cliente.' ));
			}	
}

function eliminar_abono()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::eliminar_abono($dato['id_usuario'],$dato['id_abono'],$dato['id_cuenta']);
	if($row===true)
	{ 
		$bitacora=Bitacora::guardar($dato['id_usuario'],'eliminar_abono',json_encode($dato));
	print json_encode(array('suceso' => '1' ,'mensaje'=>'Eliminado correctamente.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al eliminar la abono.' ));
			}	
}

function eliminar_cuota()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::eliminar_cuota($dato['id_usuario'],$dato['id_cuota'],$dato['id_cuenta']);
	if($row===true)
	{ 
		$bitacora=Bitacora::guardar($dato['id_usuario'],'eliminar_cuota',json_encode($dato));
	print json_encode(array('suceso' => '1' ,'mensaje'=>'Eliminado correctamente.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al eliminar la cuota.' ));
			}	
}

function eliminar_cuenta()
{
	$dato=json_decode(file_get_contents("php://input"),true); 
			
			$verificar_cuota=Cuenta::verificar_coutas_valor($dato['id_cuenta']);
			if($verificar_cuota==-1){
				$row_eliminar_cuota=Cuenta::eliminar_cuota_definitivo($dato['id_usuario'],$dato['id_cuenta']);
				$row=Cuenta::eliminar_cuenta($dato['id_cuenta'],$dato['id_usuario']);
				if($row_eliminar_cuota==true && $row===true) {
					$bitacora=Bitacora::guardar($dato['id_usuario'],'eliminar_cuenta',json_encode($dato));
					print json_encode(array('suceso' => '1' ,'mensaje'=>'Eliminado correctamente.'));
					}
					else
					{
					print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al eliminar la Cuenta. Verificar sus CUOTAS con pagos.' ));
					 }	
			}else{
				print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al eliminar la Cuenta. Verificar sus CUOTAS con pagos.' ));
				 }				 
}


function lista_cuenta()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::lista_cuenta();
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cuenta"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function lista_abonos()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::lista_abonos($dato['id_cuenta']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["abonos"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function lista_cuenta_por_cliente()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::lista_cuenta_por_cliente($dato['id_cliente']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cuenta"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}
function obtener_cuenta_por_id()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::get_cuenta_por_id($dato['id_cuenta']);
	$cuotas=Cuenta::lista_cuotas_por_id_cuenta($dato['id_cuenta']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cuenta"]=$row;
		$dato["cuotas"]=$cuotas;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No cuenta.' ));
	}
}
 

function lista_cliente_cuenta_por_id_caja()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::lista_cliente_cuenta_por_id_caja($dato['id_caja'],$dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cliente"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function actualizar_cuotas_atraso()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Cuenta::actualizar_cuotas_atraso();
	if ($row!=-1) {
		$dato["suceso"]="1";
		$dato["mensaje"]="Actualizacion de atrasos (".$row.")"; 
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No se logro actualizar el atraso.' ));
	}
}



 ?>
