<?php 
/**
* Loguear al usuario 
*/
require_once 'clsusuario.php';
require_once 'clsconfiguracion.php';
require_once 'clsbitacora.php';


//if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	
	// Decodificando formato Json
	switch ($_GET['opcion']) {
		 
		case 'iniciar_sesion':
			   iniciar_sesion();
			break;
		case 'iniciar_sesion_administrador':
				iniciar_sesion_administrador();
			 break;	
		case 'guardar':
			   guardar();
			break;
		case 'lista':
			   lista();
			break;
		case 'usuario_por_id':
			   usuario_por_id();
			break;
		case 'actualizar_datos':
			actualizar_datos();
			break;	
		  
		default:
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Actualice la aplicación.' ));
			break;
	}


function iniciar_sesion()
{
	try{
	$dato=json_decode(file_get_contents("php://input"),true);
	$retorno=Usuario::iniciar_sesion($dato['usuario'],$dato['contrasenia']);
	if ($retorno!='-1'){	

		$bitacora=Bitacora::guardar(null,'iniciar_sesion','Se inicio sesion con el usuario '.$dato['usuario']);
		//echo $retorno['id'];
		 $configuracion=Configuracion::get_configuracion_por_id($retorno['id']);
		 $dato["suceso"]= "1";
		 $dato["mensaje"]= "Se inicio correctamente.";
	  	 $dato["perfil"]=array($retorno);
	  	 $dato["configuracion"]=$configuracion;
		print json_encode($dato);				
		} else {
		 print json_encode(array('suceso' => '2' ,'mensaje'=>'Error al Iniciar Sesion.' ));	
		}
	}catch(Exception $e){
		print json_encode(array('suceso' => '2' ,'mensaje'=>'Hay una nueva actualización.' ));
	}
}
 
function iniciar_sesion_administrador()
{
	try{
	$dato=json_decode(file_get_contents("php://input"),true);
	$retorno=Usuario::iniciar_sesion($dato['usuario'],$dato['contrasenia']);
	if ($retorno!='-1'){	
		//Registrar bitacora
		$bitacora=Bitacora::guardar($dato['id_usuario'],'iniciar_sesion','Se inicio sesion desde la cuenta de usuario administrador al usuario '.$dato['usuario']);
		//echo $retorno['id'];
		 $configuracion=Configuracion::get_configuracion_por_id($retorno['id']);
		 $dato["suceso"]= "1";
		 $dato["mensaje"]= "Se inicio correctamente.";
	  	 $dato["perfil"]=array($retorno);
	  	 $dato["configuracion"]=$configuracion;
		print json_encode($dato);				
		} else {
		 print json_encode(array('suceso' => '2' ,'mensaje'=>'Error al Iniciar Sesion.' ));	
		}
	}catch(Exception $e){
		print json_encode(array('suceso' => '2' ,'mensaje'=>'Hay una nueva actualización.' ));
	}
}
 

 
function guardar()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Usuario::guardar(
		$dato['nombre'],
		$dato['tipo'],
		$dato['usuario'],
		$dato['contrasenia'],
		$dato['id_usuario_registro']);
	if($row!=false)
	{
		$configuracion=Configuracion::guardar($row);

	print json_encode(array('suceso' => '1' ,'mensaje'=>'Guardado Correctamente.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al guardar el Usuario.' ));
			}	
}
function actualizar_datos()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Usuario::actualizar_datos(
		$dato['id'],
		$dato['nombre'],
		$dato['tipo'],
		$dato['usuario'],
		$dato['contrasenia']);
	if($row===true)
	{
	print json_encode(array('suceso' => '1' ,'mensaje'=>'Correcto.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar el usuario.' ));
			}	
}



function usuario_por_id()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Usuario::usuario_por_id($dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["usuario"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun usuario.' ));
	}
}


function lista()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Usuario::lista();
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["usuarios"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun usuario.' ));
	}
}


 ?>
