<?php
include_once 'Basededatos.php'; 

class Usuario extends Database
{
    
	public function Usuario()
	{
 		parent::Database();
 		
	}
 
   public static function iniciar_sesion($usuario,$contrasenia)
   {$resultado=-1;
   	try{
   		 
		$consulta="SELECT * from usuario where usuario=? and contrasenia=?";
		$comando=parent::getInstance()->getDb()->prepare($consulta);
 		$comando->execute(array($usuario,$contrasenia));
 		$row=$comando->fetch(PDO::FETCH_ASSOC);
 		if($row)
 		{
 			$resultado=$row;
 		}
		} catch (PDOException $e) {
			echo $e;
		  $resultado=-1;
		}
		return $resultado;
   }

    
    



 public static function guardar(
 	$nombre,$tipo,$usuario,$contrasenia,$id_usuario_registro
 )
  {
    	 try{
		    $consulta="INSERT INTO usuario (nombre,tipo,usuario,contrasenia,id_usuario_registro)
			values(?,?,?,?,?)";
		    $comando=parent::getInstance()
		    ->getDb()
		    ->prepare($consulta);
		    $comando->execute(array($nombre,$tipo,$usuario,$contrasenia,$id_usuario_registro));
		    $id_usuario = parent::getInstance()->getDb()->lastInsertId();
		    
		    return $id_usuario;
		    }catch(PDOException $e)
		    { 
				echo $e;
		      return false;
		    }
  }

 
 public static function actualizar_datos(
 		$id,
 		$nombre,
 		$tipo,
 		$usuario,
 		$contrasenia)
 {
     try{
	    $consulta="UPDATE usuario 
	    set  
		nombre=?,
		tipo=?,
		usuario=?,
		contrasenia=? 
	    where id=?";

	    $comando=parent::getInstance()->getDb()->prepare($consulta);
	    $comando->execute(array($nombre,
 		$tipo,
 		$usuario,
 		$contrasenia,$id));
 		
	    return true;
    }catch(PDOException $e)
    {
    	echo $e;
      return false;
    }
}
 

 public  function lista()
   {  
   	$resultado=-1;
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT * from usuario  
   	order by nombre asc");
        $query->execute(); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;
   }


 public  function usuario_por_id($id_usuario)
   {  
   	$resultado=-1;
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT * from usuario where id=?");
        $query->execute(array($id_usuario)); 
		$row=$query->fetchAll();
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;

   }
   public  function usuario_por_id_objeto($id_usuario)
   {  
   	$resultado=-1;
   	$query = parent::getInstance()
   	->getDb()
   	->prepare("SELECT * from usuario where id=?");
        $query->execute(array($id_usuario));   
		$row=$query->fetch(PDO::FETCH_OBJ);
		if($row)
		{
			$resultado=$row;
		}
		else
			{
				$resultado=-1;
			}
	return $resultado;

   }

   

}


		

 ?>
