<?php 
/**
* Loguear al usuario 
*/
require_once 'clscaja.php';
require_once 'clsbitacora.php';
require_once 'clsusuario.php';

//if ($_SERVER['REQUEST_METHOD'] == 'POST') {
	
	// Decodificando formato Json
	switch ($_GET['opcion']) {
		case 'guardar':
			guardar();
			break;
		case 'cerrar_caja':
			cerrar_caja();
			break; 
		case 'lista':
			lista();
			break;	
		case 'caja_por_id':
			caja_por_id();
			break;
		case 'cierre_automatico_caja':
			cierre_automatico_caja();
			break;	
		case 'lista_por_id_usuario':
			lista_por_id_usuario();
			break;
		case 'informe_cobro':
			informe_cobro();
			break;
		case 'lista_cliente_cobro':
			lista_cliente_cobro();
			break;
		case 'lista_cliente_pendiente':
			lista_cliente_pendiente();
			break;	
		case 'lista_pagos_cobro_liquidada':
			lista_pagos_cobro_liquidada();
			break;	
		case 'inversion_caja':
			inversion_caja();
			break;		
		case 'utilidad':
			utilidad();
			break;		
			 
		default:
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Actualice la aplicación.' ));
			break;
	}

 
function guardar()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	if(Caja::verificar_caja_abierta_por_id_usuario($dato['id_usuario'])==false){
		$row=Caja::guardar($dato['id_usuario'],$dato['nombre_caja'],$dato['monto_abrir']);
			if($row===true)
			{ 
			print json_encode(array('suceso' => '1' ,'mensaje'=>'Guardado correctamente.'));
			}
			else{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al guardar .' ));
			}	
	}else{
		print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Ya tiene una caja abierta con su usuario .' ));
	}
	
}

function cerrar_caja()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::cerrar_caja($dato['id_caja'],$dato['id_usuario'],$dato['monto_cierre']);
	if($row===true)
	{  
	print json_encode(array('suceso' => '1' ,'mensaje'=>'Correcto.'));
	}
	else
	{
	print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar el cliente.' ));
			}	
}

function inversion_caja()
{
	$dato=json_decode(file_get_contents("php://input"),true); 
		$row=Caja::inversion_caja($dato['id_usuario'],$dato['id_caja'],$dato['monto_inversion']);
			if($row===true)
			{ 
			$bitacora=Bitacora::guardar($dato['id_usuario'],'inversion_caja','inversion-> '.json_encode($dato));
			print json_encode(array('suceso' => '1' ,'mensaje'=>'Se realizo la inversión correctamente.'));
			}
			else{
			print json_encode(array('suceso' => '2' ,'mensaje'=>'Error: Al actualizar .' ));
			}	
}

function utilidad()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::utilidad($dato['id_usuario'],$dato['id_usuario_buscar'],$dato['anio'],$dato['mes']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["utilidad"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function caja_por_id()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::caja_por_id($dato['id_caja']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["caja"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function cierre_automatico_caja()
{
	
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::cierre_automatico_caja();
	//echo 'respuesta'.$row;
	if ($row!=-1) {
		$dato["suceso"]="1";
		$dato["mensaje"]="Cierre de cajas automatico ->".$row; 
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'Error: al realizar el cierre automatico.' ));
	}
}

function lista_por_id_usuario()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::lista_por_id_usuario($dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cajas"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}
function lista()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::lista_por_id_usuario($dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cajas"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}
 
function informe_cobro()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row=Caja::informe_cobro($dato['id_usuario']);
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["caja"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function lista_cliente_cobro()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row="-1";
	if($dato['parametrica']=='lista_cobrado_liquidada'){
		$row=Caja::lista_cliente_cobro_liquidada($dato['id_caja'],$dato['id_usuario'],$dato['parametrica']);
	}else{
		$row=Caja::lista_cliente_cobro_dia($dato['id_caja'],$dato['id_usuario'],$dato['parametrica']);
	}
	
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cliente"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}


function lista_pagos_cobro_liquidada()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row="-1"; 
	$row=Caja::lista_pagos_cobro_liquidada($dato['id_caja'],$dato['id_usuario'],$dato['id_cliente']);
	 
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["pagos"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}

function lista_cliente_pendiente()
{
	$dato=json_decode(file_get_contents("php://input"),true);
	$row="-1";
	$usuario=Usuario::usuario_por_id_objeto($dato['id_usuario']);
	$tipo_usuario= $usuario->tipo;
	if($tipo_usuario=='ADMINISTRADOR'){
		$row=Caja::lista_cliente_pendiente_administrador($dato['id_caja'],$dato['id_usuario']);
	}else{
		$row=Caja::lista_cliente_pendiente($dato['id_caja'],$dato['id_usuario']);
	}
	
	  
	if ($row!="-1") {
		$dato["suceso"]="1";
		$dato["mensaje"]="Correcto";
		$dato["cliente"]=$row;
		print json_encode($dato);
	}
	else
	{
		print json_encode(array('suceso' =>'2' ,'mensaje'=>'No hay ningun dato.' ));
	}
}


 ?>
